// OpenGL_NXDlg.cpp : implementation file
//

#include "stdafx.h"
#include "OpenGL_NX.h"
#include "OpenGL_NXDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

#define		Fwrite		ExFile.Write( String, String.GetLength() )
#define		SFormat		String.Format
#define		LineFeed	String.Format("\n");Fwrite;
#define		FwriteLine	Fwrite;LineFeed;

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// COpenGL_NXDlg dialog

COpenGL_NXDlg::COpenGL_NXDlg(CWnd* pParent /*=NULL*/)
	: CDialog(COpenGL_NXDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(COpenGL_NXDlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void COpenGL_NXDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(COpenGL_NXDlg)
	DDX_Control(pDX, IDC_IMPORT_BTN, m_ImportBtn);
	DDX_Control(pDX, IDC_LIST, m_List);
	DDX_Control(pDX, IDC_DISPLAY_LIST, m_DisplayBtn);
	DDX_Control(pDX, IDC_PRG_MSG_LIST, m_Msg);
	DDX_Control(pDX, IDC_SCENE_TREE, m_Scene);
	DDX_Control(pDX, IDC_PROGRESS1, m_PrgBar);
	DDX_Control(pDX, IDC_EXPORT_BTN, m_ExportBtn);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(COpenGL_NXDlg, CDialog)
	//{{AFX_MSG_MAP(COpenGL_NXDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_HELP_BTN, OnHelpBtn)
	ON_BN_CLICKED(IDC_IMPORT_BTN, OnImportBtn)
	ON_BN_CLICKED(IDC_DISPLAY_LIST, OnDisplayList)
	ON_NOTIFY(TVN_SELCHANGED, IDC_SCENE_TREE, OnSelchangedSceneTree)
	ON_BN_CLICKED(IDC_SUMMARY_BTN, OnSummaryBtn)
	ON_BN_CLICKED(IDC_EXPORT_BTN, OnExportBtn)
	ON_WM_DROPFILES()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// COpenGL_NXDlg message handlers

BOOL COpenGL_NXDlg::OnInitDialog()
{
	CDialog::OnInitDialog();


	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}
	
	MsgCount = 0;


	DragAcceptFiles();
	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	SceneNode = m_Scene.InsertItem( "Scene", NULL, 0, TVI_ROOT );
	ObjectNode = m_Scene.InsertItem( "Objects", NULL, 0, SceneNode );
	MaterialNode = m_Scene.InsertItem( "Materials", NULL, 0, SceneNode );

	m_Msg.InsertColumn( 1, "Messages", LVCFMT_LEFT, 170 );
	m_Msg.InsertItem( MsgCount++, "Ready...", 0 );

	m_List.InsertColumn( 1, "Number", LVCFMT_LEFT, 50 );
	m_List.InsertColumn( 2, "X/A", LVCFMT_LEFT, 80 );
	m_List.InsertColumn( 3, "Y/B", LVCFMT_LEFT, 80 );
	m_List.InsertColumn( 4, "Z/C", LVCFMT_LEFT, 80 );
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void COpenGL_NXDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void COpenGL_NXDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);


	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR COpenGL_NXDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void COpenGL_NXDlg::OnHelpBtn() 
{
	// TODO: Add your control notification handler code here
	HINSTANCE result;
	result = ShellExecute( NULL, NULL, HELP_HTML_PAGE, NULL, NULL, 1);
	
}

void COpenGL_NXDlg::OnImportBtn() 
{
	// TODO: Add your control notification handler code here


	
	static TCHAR szFilter[] = _T("ASE file import (*.ase)|*.ase|All files (*.*)|*.*|");

	CFileDialog InFileDlg( TRUE, _T("*.asc"),NULL , OFN_PATHMUSTEXIST, szFilter, NULL );
	InFileDlg.m_ofn.lpstrTitle = "Import 3Ds Max ASE file";
	if( InFileDlg.DoModal() != IDOK )
		return;


	ImportFile( InFileDlg.GetFileName() );

	CheckHeads();
	
	
	
}

void COpenGL_NXDlg::CreateDataBase()
{
	FreeHeads();


	bool flag=TRUE;
	int i;
	char tempstr[50];
	Pos = 0;
	Pos = ASEText.Find( "*MATERIAL_COUNT ", 0 )+16;
	ReadValue( Pos, tempstr );
	MaterialCount = atoi( tempstr );

	m_Msg.InsertItem( MsgCount++, "Creating Material Lib", 0 );
	Pos = 0;
	MaterialLib = ReadMaterial(  MaterialNode, MaterialCount );
	

	m_Msg.InsertItem( MsgCount++, "Searching Objects", 0 );
	i = 0;
	Pos = 0;
	ObjectCount = 0;
	Object *tempObj,*temp1Obj;
	flag = TRUE;
	while( 1 )
	{
		Pos = ASEText.Find( "*GEOMOBJECT ", Pos );
		if( Pos > 0 )
		{
			tempObj = new Object;
			ObjectCount++;
			if( flag == TRUE ) 
			{
				SceneObj = tempObj;
				flag = FALSE;
			}
			else
				temp1Obj->NxObject = tempObj;

			Pos = ASEText.Find( "*NODE_NAME ", Pos );
			ReadChar( Pos+12, tempObj->Name );
			tempObj->Pos = Pos;
			Pos = ASEText.Find( "*MESH_NUMVERTEX ",Pos );
			ReadValue( Pos+16, tempstr );
			tempObj->VertexCount = atoi( tempstr );

			Pos = ASEText.Find( "*MESH_NUMFACES ",Pos );
			ReadValue( Pos+15, tempstr );
			tempObj->FaceCount = atoi( tempstr );
			
			Pos = ASEText.Find("*MESH_NUMTVERTEX ", Pos );
			ReadValue( Pos+17, tempstr );
			tempObj->TVertexCount = atoi( tempstr );
			tempObj->NxObject = NULL;
			tempObj->FaceList = NULL;
			tempObj->VertexList = NULL;
			tempObj->TVertexList = NULL;
			temp1Obj = tempObj;

			tempObj->TreeNode = m_Scene.InsertItem( tempObj->Name, 0, 1, ObjectNode );
		}
		else
			break;	
	}
	if( SceneObj == NULL )
	{
		m_Msg.InsertItem( MsgCount++, "Error:0 Objects Found", 0 );
		m_Msg.InsertItem( MsgCount++, "Aborting...", 0 );
		AfxMessageBox("This is Not the proper input file...");
		return;
	}
	sprintf( tempstr, "%d Objects found", ObjectCount );
	m_Msg.InsertItem( MsgCount++, tempstr , 0 );
	VertexNode *tmpV, *tmpV1;


	tempObj = SceneObj;

	int counter=1;
	while( 1 )
	{
		temp1Obj = tempObj;
		Pos = tempObj->Pos;
		flag = TRUE;
		sprintf( tempstr, "Perparing Object %d", counter++ );
		m_Msg.InsertItem( MsgCount++, tempstr , 0 );


		sprintf( tempstr, "Reading Verties...");
		m_Msg.InsertItem( MsgCount++, tempstr , 0 );

		tempObj->VertexNode = m_Scene.InsertItem( "Verties", 0, 0, tempObj->TreeNode );

		for( i=0; i< tempObj->VertexCount; i++)
		{
			Pos = ASEText.Find( "*MESH_VERTEX ", Pos );
			Pos = Pos+18;
			ReadValue( Pos, tempstr );
			tmpV = new VertexNode;
			
			if( flag == TRUE )
			{
				flag = FALSE;
				tempObj->VertexList = tmpV;
			}
			else
				tmpV1->NxNode = tmpV;
			tmpV->x = -(float)atof( tempstr );
			
			Pos = Pos+strlen( tempstr )+1;
			ReadValue( Pos,tempstr );
			tmpV->z = (float)atof( tempstr );
	
			Pos = Pos+strlen( tempstr )+1;
			ReadValue( Pos, tempstr );
			tmpV->y = (float)atof( tempstr );
			tmpV->NxNode = NULL;
			tmpV1 = tmpV;
		}
		FaceNode *tmpf, *tmpf1;
		flag = TRUE;

		//Pos = tempObj->Pos;

		sprintf( tempstr, "Reading Faces...");
		m_Msg.InsertItem( MsgCount++, tempstr , 0 );

		tempObj->FaceNode = m_Scene.InsertItem( "Faces", 0, 0, tempObj->TreeNode );

		Pos = ASEText.Find( "*MESH_FACE_LIST", Pos );
		Pos++;
		
		for( i=0; i< tempObj->FaceCount; i++ )
		{
			Pos = ASEText.Find( "*MESH_FACE ",Pos );
			tmpf = new FaceNode;
			
			if( flag == TRUE )
			{
				flag = FALSE;
				tempObj->FaceList = tmpf;
			}
			else
				tmpf1->NxNode = tmpf;
			Pos = ASEText.Find( " A:",Pos );
			ElimnetSpaces( Pos+3, tempstr );
			tmpf->a = atoi( tempstr );
	
			Pos = ASEText.Find( " B:",Pos );
			ElimnetSpaces( Pos+3, tempstr );
			tmpf->b = atoi( tempstr );
	
			Pos = ASEText.Find( " C:",Pos );
			ElimnetSpaces( Pos+3, tempstr );
			tmpf->c = atoi( tempstr );
	
			Pos = ASEText.Find( "*MESH_MTLID ", Pos );
			ReadValue( Pos+12, tempstr );
			tmpf->MaterialID = atoi( tempstr );
			tmpf->NxNode = NULL;
			tmpf1 = tmpf;
		}
		Pos = tempObj->Pos;
		TVertexNode *tempT,*tempT1;
		flag = TRUE;

		sprintf( tempstr, "Reading TextVerteies...");
		m_Msg.InsertItem( MsgCount++, tempstr , 0 );

		tempObj->TvertexNode = m_Scene.InsertItem( "Texture Verties", 0, 0, tempObj->TreeNode );
		for( i=0; i<tempObj->TVertexCount; i++ )
		{
			tempT = new TVertexNode;
			if( flag == TRUE )
			{
				flag = FALSE;
				tempObj->TVertexList = tempT;
			}
			else
				tempT1->NxNode = tempT;

			Pos = ASEText.Find( "*MESH_TVERT ", Pos );
			itoa( i, tempstr, 10 );
			Pos = Pos + 12 + strlen( tempstr )+1;
			ReadValue( Pos, tempstr );
			tempT->u = (float)atof( tempstr );

			Pos = Pos + strlen( tempstr ) +1 ;
			ReadValue( Pos, tempstr );
			tempT->v = (float)atof( tempstr );

			Pos = Pos + strlen( tempstr ) +1 ;
			ReadValue( Pos, tempstr );
			tempT->w = (float)atof( tempstr );

			tempT->NxNode = NULL;
			tempT1 = tempT;
		}
		tmpf = tempObj->FaceList;
		Pos = tempObj->Pos;
		sprintf( tempstr, "Updating Faces with TextVerteies...");
		m_Msg.InsertItem( MsgCount++, tempstr , 0 );

		tempObj->FaceTVertexNode = m_Scene.InsertItem( "Face Texture Verties", 0, 0, tempObj->TreeNode );
		for( i=0; i<tempObj->FaceCount; i++ )
		{
			Pos = ASEText.Find( "*MESH_TFACE ", Pos );
			itoa( i, tempstr, 10 );
			Pos = Pos + 13 +strlen( tempstr );
			ReadValue( Pos, tempstr );
			tmpf->aTextVertex = atoi( tempstr );

			Pos = strlen( tempstr )+1+Pos;
			ReadValue( Pos, tempstr );
			tmpf->bTextVertex = atoi( tempstr );

			Pos = strlen( tempstr )+1+Pos;
			ReadValue( Pos, tempstr );
			tmpf->cTextVertex = atoi( tempstr );
			tmpf = tmpf->NxNode;
		}
		tmpf = tempObj->FaceList;
		Pos = tempObj->Pos;

		sprintf( tempstr, "Updating FaceNormals...");
		m_Msg.InsertItem( MsgCount++, tempstr , 0 );

		tempObj->FaceNormalNode = m_Scene.InsertItem( "Face Normals", 0, 0, tempObj->TreeNode );
		for( i = 0; i<tempObj->FaceCount; i++ )
		{
			Pos = ASEText.Find( "*MESH_FACENORMAL ", Pos );
			itoa( i, tempstr, 10 );
			Pos = Pos + 17 + strlen( tempstr ) + 1 ;
			ReadValue( Pos, tempstr );
			tmpf->Normalx = (float)atof( tempstr );

			Pos = strlen( tempstr ) + 1 + Pos;
			ReadValue( Pos, tempstr );
			tmpf->Normalz = (float)atof( tempstr );

			Pos = strlen( tempstr ) + 1 + Pos;
			ReadValue( Pos, tempstr );
			tmpf->Normaly = (float)atof( tempstr );


			// Changes Mad	While reading Vertex  y<->z 
			//				While reading TVertex v<->w
			//				While reading Normals y<->z
			tmpf = tmpf->NxNode;
		}

		Pos = ASEText.Find( "*MATERIAL_REF ", Pos );
		ReadValue( Pos + 14, tempstr );
		tempObj->MaterialRef = atoi( tempstr );
		tempObj  = tempObj->NxObject;
		if( tempObj == NULL )
			break;
	}
	m_ExportBtn.EnableWindow( );
}

void COpenGL_NXDlg::FreeHeads()
{
	
	m_Scene.DeleteAllItems();
	SceneNode = m_Scene.InsertItem( "Scene", NULL, 0, TVI_ROOT );
	ObjectNode = m_Scene.InsertItem( "Objects", NULL, 0, SceneNode );
	MaterialNode = m_Scene.InsertItem( "Materials", NULL, 0, SceneNode );


	SceneObj = NULL;
	
	MaterialLib = NULL;
	

	m_Msg.DeleteAllItems();

	m_Msg.InsertColumn( 1, "Messages", LVCFMT_LEFT, 170 );
	m_Msg.InsertItem( MsgCount++, "Ready...", 0 );

	m_List.InsertColumn( 1, "Number", LVCFMT_LEFT, 50 );
	m_List.InsertColumn( 2, "X/A", LVCFMT_LEFT, 80 );
	m_List.InsertColumn( 3, "Y/B", LVCFMT_LEFT, 80 );
	m_List.InsertColumn( 4, "Z/C", LVCFMT_LEFT, 80 );

}

void COpenGL_NXDlg::ReadChar( int Pos, char *str,int count )
{
	int index=0;

	
	while( ( ASEText[Pos] >=65 && ASEText[Pos] <=90 )
		|| ( ASEText[Pos] >=97 && ASEText[Pos] <=122 )
		|| ( ASEText[Pos] >=48 && ASEText[Pos] <=57 ) 
		|| ASEText[Pos] == 95)
	{
		
		str[index] = ASEText[Pos];
		Pos++;
		index++;
		if( count != -1 && index == count )
			break;
	}
	str[index]=0;
	if( index == 0 )
		str = NULL;


}

void COpenGL_NXDlg::ReadValue( int Pos1, char *tstr)
{
	int index=0;
	char ch;
	
	while( 1 )
	{
		ch = ASEText[ Pos1 ];
		if(	(ch >= 48 && ch <= 57) 
			|| ch == 46 || ch == 45 )
		{
			tstr[index] = ch;
			Pos1++;
			index++;
		}
		else
			break;
		
	}
	tstr[ index ] = 0;

}

void COpenGL_NXDlg::OnDisplayList() 
{
	// TODO: Add your control notification handler code here
	Object *tObj;
	tObj = SceneObj;
	HTREEITEM titem;
	titem = m_Scene.GetSelectedItem();
	while( 1 )
	{
		if( titem == tObj->VertexNode )
		{
			ShowVerties( tObj->VertexList );
			break;
		}
		if( titem == tObj->FaceNode )
		{
			ShowFaces( tObj->FaceList );
			break;
		}
		if( titem == tObj->TvertexNode )
		{
			ShowTextVerties( tObj->TVertexList );			
			break;
		}
		if( titem == tObj->FaceNormalNode )
		{
			ShowFaceNormals( tObj->FaceList );
			break;
		}
		if( titem == tObj->FaceTVertexNode )
		{
			ShowFaceTVerties( tObj->FaceList );
		}
		if( titem == MaterialNode )
		{
			ShowMaterialLib( );
		}
		tObj = tObj->NxObject;
		if( tObj == NULL )
		{
			break;
		}
	}
	

}

void COpenGL_NXDlg::ShowVerties( VertexNode *List)
{
	m_List.EnableWindow();
	m_List.DeleteAllItems();
	m_List.DeleteColumn( 2 );
	m_List.DeleteColumn( 2 );
	m_List.DeleteColumn( 1 );
	m_List.DeleteColumn( 4 );
	
	m_List.InsertColumn( 1, "X", LVCFMT_LEFT, 80 );
	m_List.InsertColumn( 2, "Y", LVCFMT_LEFT, 80 );
	m_List.InsertColumn( 3, "Z", LVCFMT_LEFT, 80 );

	int i=0;
	char tempstr[30];
	LV_ITEM litem;

	litem.mask = LVIF_TEXT;
	while( 1 )
	{
		litem.iItem  = i;
		litem.iSubItem = 0;
		itoa( i , tempstr, 10 );
		litem.pszText = tempstr;
		m_List.InsertItem( &litem );	

		litem.iSubItem = 1;
		sprintf( tempstr, "%ff", List->x );
		litem.pszText = tempstr;
		m_List.SetItem( &litem );

		litem.iSubItem = 2;
		sprintf( tempstr, "%ff", List->y );
		litem.pszText = tempstr;
		m_List.SetItem( &litem );

		litem.iSubItem = 3;
		sprintf( tempstr, "%ff", List->z );
		litem.pszText = tempstr;
		m_List.SetItem( &litem );

		List = List->NxNode;
		i++;
		if( List == NULL )
			break;
	}
}

void COpenGL_NXDlg::ShowFaces(FaceNode *List)
{
	m_List.EnableWindow();
	m_List.DeleteAllItems();
	m_List.DeleteColumn( 2 );
	m_List.DeleteColumn( 2 );
	m_List.DeleteColumn( 1 );
	m_List.DeleteColumn( 4 );
	
	m_List.InsertColumn( 1, "A", LVCFMT_LEFT, 80 );
	m_List.InsertColumn( 2, "B", LVCFMT_LEFT, 80 );
	m_List.InsertColumn( 3, "C", LVCFMT_LEFT, 80 );
	m_List.InsertColumn( 4, "MaterialID", LVCFMT_LEFT, 80 );

	int i=0;
	char tempstr[30];
	LV_ITEM litem;

	litem.mask = LVIF_TEXT;
	while( 1 )
	{
		litem.iItem  = i;
		litem.iSubItem = 0;
		itoa( i , tempstr, 10 );
		litem.pszText = tempstr;
		m_List.InsertItem( &litem );	

		litem.iSubItem = 1;
		sprintf( tempstr, "%d", List->a );
		litem.pszText = tempstr;
		m_List.SetItem( &litem );

		litem.iSubItem = 2;
		sprintf( tempstr, "%d", List->b );
		litem.pszText = tempstr;
		m_List.SetItem( &litem );

		litem.iSubItem = 3;
		sprintf( tempstr, "%d", List->c );
		litem.pszText = tempstr;
		m_List.SetItem( &litem );

		litem.iSubItem = 4;
		sprintf( tempstr, "%d", List->MaterialID );
		litem.pszText = tempstr;
		m_List.SetItem( &litem );

		List = List->NxNode;
		i++;
		if( List == NULL )
			break;
	}

}

void COpenGL_NXDlg::ShowTextVerties(TVertexNode *List)
{
	m_List.EnableWindow();
	m_List.DeleteAllItems();
	m_List.DeleteColumn( 2 );
	m_List.DeleteColumn( 2 );
	m_List.DeleteColumn( 1 );
	m_List.DeleteColumn( 4 );
	
	m_List.InsertColumn( 1, "U", LVCFMT_LEFT, 80 );
	m_List.InsertColumn( 2, "V", LVCFMT_LEFT, 80 );
	m_List.InsertColumn( 3, "W", LVCFMT_LEFT, 80 );

	if( List == NULL )
		return;
	int i=0;
	char tempstr[30];
	LV_ITEM litem;

	litem.mask = LVIF_TEXT;
	while( 1 )
	{
		litem.iItem  = i;
		litem.iSubItem = 0;
		itoa( i , tempstr, 10 );
		litem.pszText = tempstr;
		m_List.InsertItem( &litem );	

		litem.iSubItem = 1;
		sprintf( tempstr, "%ff", List->u );
		litem.pszText = tempstr;
		m_List.SetItem( &litem );

		litem.iSubItem = 2;
		sprintf( tempstr, "%ff", List->v );
		litem.pszText = tempstr;
		m_List.SetItem( &litem );

		litem.iSubItem = 3;
		sprintf( tempstr, "%ff", List->w );
		litem.pszText = tempstr;
		m_List.SetItem( &litem );

		List = List->NxNode;
		i++;
		if( List == NULL )
			break;
	}
}

void COpenGL_NXDlg::ShowFaceNormals(FaceNode *List)
{
	if( List == NULL )
		return;
	m_List.EnableWindow();
	m_List.DeleteAllItems();
	m_List.DeleteColumn( 2 );
	m_List.DeleteColumn( 2 );
	m_List.DeleteColumn( 1 );
	m_List.DeleteColumn( 4 );
	
	m_List.InsertColumn( 1, "i", LVCFMT_CENTER, 80 );
	m_List.InsertColumn( 2, "j", LVCFMT_CENTER, 80 );
	m_List.InsertColumn( 3, "k", LVCFMT_CENTER, 80 );

	
	int i=0;
	char tempstr[30];
	LV_ITEM litem;

	litem.mask = LVIF_TEXT;
	while( 1 )
	{
		litem.iItem  = i;
		litem.iSubItem = 0;
		itoa( i , tempstr, 10 );
		litem.pszText = tempstr;
		m_List.InsertItem( &litem );	

		litem.iSubItem = 1;
		sprintf( tempstr, "%ff", List->Normalx );
		litem.pszText = tempstr;
		m_List.SetItem( &litem );

		litem.iSubItem = 2;
		sprintf( tempstr, "%ff", List->Normaly );
		litem.pszText = tempstr;
		m_List.SetItem( &litem );

		litem.iSubItem = 3;
		sprintf( tempstr, "%ff", List->Normalz );
		litem.pszText = tempstr;
		m_List.SetItem( &litem );

		List = List->NxNode;
		i++;
		if( List == NULL )
			break;
	}
}

void COpenGL_NXDlg::ShowFaceTVerties(FaceNode *List)
{
	if( List == NULL )
		return;
	m_List.EnableWindow();
	m_List.DeleteAllItems();
	m_List.DeleteColumn( 2 );
	m_List.DeleteColumn( 2 );
	m_List.DeleteColumn( 1 );
	m_List.DeleteColumn( 4 );
	
	m_List.InsertColumn( 1, "A", LVCFMT_LEFT, 80 );
	m_List.InsertColumn( 2, "B", LVCFMT_LEFT, 80 );
	m_List.InsertColumn( 3, "C", LVCFMT_LEFT, 80 );

	int i=0;
	char tempstr[30];
	LV_ITEM litem;

	litem.mask = LVIF_TEXT;
	while( 1 )
	{
		litem.iItem  = i;
		litem.iSubItem = 0;
		itoa( i , tempstr, 10 );
		litem.pszText = tempstr;
		m_List.InsertItem( &litem );	

		litem.iSubItem = 1;
		sprintf( tempstr, "%d", List->aTextVertex );
		litem.pszText = tempstr;
		m_List.SetItem( &litem );

		litem.iSubItem = 2;
		sprintf( tempstr, "%d", List->bTextVertex );
		litem.pszText = tempstr;
		m_List.SetItem( &litem );

		litem.iSubItem = 3;
		sprintf( tempstr, "%d", List->cTextVertex );
		litem.pszText = tempstr;
		m_List.SetItem( &litem );

		List = List->NxNode;
		i++;
		if( List == NULL )
			break;
	}

}

void COpenGL_NXDlg::OnSelchangedSceneTree(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_TREEVIEW* pNMTreeView = (NM_TREEVIEW*)pNMHDR;

	OnDisplayList();		
	*pResult = 0;
}

void COpenGL_NXDlg::OnSummaryBtn() 
{

}

void COpenGL_NXDlg::ShowMaterialLib()
{
	Material *tm = MaterialLib;
	m_List.EnableWindow();
	m_List.DeleteAllItems();
	m_List.DeleteColumn( 2 );
	m_List.DeleteColumn( 2 );
	m_List.DeleteColumn( 1 );
	m_List.DeleteColumn( 4 );
	
	m_List.InsertColumn( 1, "Material Name ", LVCFMT_LEFT, 200 );
	
	int i=0;
	char tempstr[30];
	LV_ITEM litem;

	litem.mask = LVIF_TEXT;
	while( 1 )
	{
		if( tm == NULL )
			return;
		litem.iItem  = i;
		litem.iSubItem = 0;
		itoa( i , tempstr, 10 );
		litem.pszText = tempstr;
		m_List.InsertItem( &litem );	

		litem.iSubItem = 1;
		sprintf( tempstr, "%s", tm->MaterialName );
		litem.pszText = tempstr;
		m_List.SetItem( &litem );

		tm = tm->NxItem;
		i++;
		if( tm == NULL )
			break;
	}

}

void COpenGL_NXDlg::OnExportBtn() 
{


	CString FileName;
	static char szFilter[] = _T("OpenGL Code file (*.h)|*.h|");
	CFileDialog ExFileDlg( FALSE, _T("*.h"), NULL, OFN_HIDEREADONLY, szFilter, NULL);
	
	if( ExFileDlg.DoModal()  != IDOK )
		return;
	
	FileName = ExFileDlg.GetFileName();

	Export( FileName );
	

	
}

Material* COpenGL_NXDlg::ReadMaterial( HTREEITEM TreeNode, int i )
{
	int c;
	char tempstr[80];
	Material *tm;

	i--;
	if( i < 0 )
		return NULL;
	Pos = ASEText.Find( "*MATERIAL_NAME ",Pos );
	if( Pos> 0 )
	{
		tm = new Material;
		ReadChar( Pos+16, tempstr, 25 );
		strcpy( tm->MaterialName, tempstr );
		Pos = ASEText.Find( "*MATERIAL_CLASS ", Pos )+17;
		ReadChar( Pos, tempstr, 25 );
		strcpy( tm->MaterialClass, tempstr );

		sprintf( tempstr, "%s ( %s )",tm->MaterialName, tm->MaterialClass );
		tm->TreeNode = m_Scene.InsertItem( tempstr, 0, 0, TreeNode );

		
		if( strcmp( tm->MaterialClass, "Multi" ) == 0 )
		{
			Pos = ASEText.Find( "*NUMSUBMTLS ", Pos )+12;
			ReadValue( Pos, tempstr );
			c = atoi( tempstr );
			tm->SubMaterials = ReadMaterial( tm->TreeNode ,c);
		}
		tm->NxItem = ReadMaterial( TreeNode ,i);
		return tm;
	}
	return NULL;
}

TVertexNode * COpenGL_NXDlg::GetTextVertex(int index, TVertexNode *Head)
{
	TVertexNode *Runner = Head;
	if( Head == NULL )
	{
		return NULL;
	}
	for( int i = 0; i<index; i++ )
		Runner = Runner->NxNode;
	return Runner;
}

VertexNode * COpenGL_NXDlg::GetVertex(int index, VertexNode *Head)
{
	VertexNode *Runner = Head;
	for( int i = 0; i<index ; i++ )
		Runner = Runner->NxNode;
	return Runner;

}

void COpenGL_NXDlg::ElimnetSpaces(int pos, char *tstr)
{
	int i=0;
	char ch;
	while( (ch =ASEText[ pos + i]) == ' ' )
	{
		i++;
	}
	ReadValue( pos+i, tstr );
}

void COpenGL_NXDlg::OnDropFiles(HDROP hDropInfo) 
{
	// TODO: Add your message handler code here and/or call default
	//AfxMessageBox( "File is droped");
	char tempstr[200];
	DragQueryFile( hDropInfo, 0, tempstr, 200 );
	ImportFile( tempstr );

	CDialog::OnDropFiles(hDropInfo);
}

void COpenGL_NXDlg::ImportFile(CString filename)
{
	CFile InFile;
	CFileStatus InFileStatus;

	char *Text;

	CString FileName = filename;


	

	if( !InFile.Open( FileName, CFile::modeRead ) )
	{
		TRACE( "Error in Opening Import file");
			return;
	}
	
	InFile.GetStatus( FileName, InFileStatus );	

	if( InFileStatus.m_size < 2 )
	{
		AfxMessageBox( " Invalid Import File", MB_OK );
		return;
	}
	Text = (char *) GlobalAlloc( GPTR, InFileStatus.m_size+1 );
	InFile.Read( Text,InFileStatus.m_size);
	InFile.Close();

	ASEText = Text;
	
	//GlobalFree( Text );
	


	CreateDataBase();
	m_Scene.EnableWindow();
	m_DisplayBtn.EnableWindow( );
	m_Scene.Expand( ObjectNode, TVE_EXPAND );
	m_Scene.Expand( SceneNode, TVE_EXPAND );

	//OnExportBtn();
}

BOOL COpenGL_NXDlg::OnCmdMsg(UINT nID, int nCode, void* pExtra, AFX_CMDHANDLERINFO* pHandlerInfo) 
{
	// TODO: Add your specialized code here and/or call the base class

	return CDialog::OnCmdMsg(nID, nCode, pExtra, pHandlerInfo);
}

void COpenGL_NXDlg::Export(CString FileName)
{
	CFile ExFile;
	int i;
	CString str;

	if( ExFile.Open( FileName, CFile::modeCreate | CFile::modeWrite ) == FALSE )
	{
		AfxMessageBox( "File Creation error...",MB_OK);
		return;
	}
	CString String;
	LineFeed;
	SFormat( "//--------------------------------------------------------------------------" );
	Fwrite;
	LineFeed;
	SFormat( "//\t\t\t OpenGL Code Generated by OpenGL NX\t\t");
	Fwrite;
	LineFeed;
	SFormat( "//--------------------------------------------------------------------------" );
	Fwrite;
	LineFeed;

	SFormat("//\t\t\t Material Lib definations:");
	FwriteLine;
	LineFeed;
	// Writing Material Lib
	SFormat("#define\t\tMAX_MATERIALS\t\t%d", MaterialCount);
	FwriteLine;
	Material *tm;
	tm = MaterialLib;
	i = 0;
	
	LineFeed;
	SFormat("UINT MaterialLib[ MAX_MATERIALS ];");
	FwriteLine;

	SFormat("//--------------------------------------------------------------------------");
	FwriteLine;
	tm = MaterialLib;
	while( tm != NULL )
	{
		if( strcmp( tm->MaterialClass, "Multi" ) == 0 )
		{
			Material *mt;
			mt = tm->SubMaterials;
			while( mt != NULL )
			{
				SFormat( "#define\t\t%s\t\t%d",mt->MaterialName,i);
				Fwrite; LineFeed;
				SFormat( "#define\t\t%s_MapFile\t\t\"TextureMaps\\\\%s.bmp\"",
						mt->MaterialName, mt->MaterialName );
				Fwrite;
				LineFeed;
				mt = mt->NxItem;
				i++;
			}
		}		
		else
		{
			SFormat( "#define\t\t%s\t\t%d",tm->MaterialName,i);
			Fwrite; LineFeed;
			SFormat("#define\t\t%s_MapFile\t\t\"TextureMaps\\\\%s.bmp\"",tm->MaterialName, tm->MaterialName );
			Fwrite;
			LineFeed;
			
		}
		tm = tm->NxItem;
		i++;
	}
	LineFeed;LineFeed;
	SFormat("//--------------------------------------------------------------------------");
	FwriteLine;
	SFormat("//\t\t\t Scene Objects :");
	FwriteLine;
	Object *tobj;
	tobj = SceneObj;
	while( tobj != NULL )
	{
		SFormat("//\t Object Name : %s", tobj->Name );
		FwriteLine;
		SFormat("//\t\t Vertex Count         : %d", tobj->VertexCount );FwriteLine;
		SFormat("//\t\t Face Count           : %d", tobj->FaceCount );FwriteLine;
		SFormat("//\t\t Texture Vertex Count : %d", tobj->TVertexCount );FwriteLine;
		tobj = tobj->NxObject;
	}
	tobj = SceneObj;
	i = 0;
	LineFeed;
	while( tobj != NULL )
	{
		str = tobj->Name ;
		str.MakeUpper();
		SFormat("#define\t\t%s %d", str, 100+i );
		FwriteLine;
		
		tobj = tobj->NxObject;
		i++;
	}
	SFormat("//--------------------------------------------------------------------------");
	FwriteLine;
	LineFeed;
	LineFeed;
	SFormat("//\t\t\t Function Prototypes");
	FwriteLine;
	SFormat("void\t\tCreateMaterialLib( void );");
	FwriteLine;
	tobj = SceneObj;
	while( tobj != NULL )
	{
		SFormat("void\t\tCreate%s( void );", tobj->Name );
		FwriteLine;
		tobj = tobj->NxObject;
	}
	LineFeed;
	SFormat("//--------------------------------------------------------------------------");
	FwriteLine;
	SFormat( "//\t\t\t Function Definations");
	
	
	SFormat( "void\t\tCreateMaterialLib( void )\n{");
	FwriteLine;
	

	i=0;
	tm = MaterialLib;
	while( tm != NULL )
	{
		if( strcmp( tm->MaterialClass, "Multi" ) == 0 )
		{
			Material *mt;
			mt = tm->SubMaterials;
			while( mt != NULL )
			{
				SFormat( "\t\tCreateTexture( MaterialLib, %s_MapFile, %d );", 
						mt->MaterialName, i );
				Fwrite;
				LineFeed;
				mt = mt->NxItem;
				i++;
			}
		}		
		else
		{
				SFormat( "\t\tCreateTexture( MaterialLib, %s_MapFile, %d );", 
						tm->MaterialName, i );
				Fwrite;
				LineFeed;
		}
		tm = tm->NxItem;
		i++;
	}

	
	
	
	
	
	
	
	
	SFormat("}");
	FwriteLine;
	LineFeed;

	int ID = 0;
	FaceNode *tmpf;
	TVertexNode *tmptv;
	VertexNode *tmpv;

	tobj = SceneObj;
	while( tobj != NULL )
	{
		SFormat("void\t\tCreate%s( void )\n{", tobj->Name );
		FwriteLine;
		str = tobj->Name;
		str.MakeUpper();
		SFormat("\tglNewList( %s, GL_COMPILE );", str );
		FwriteLine;

		// Code is Incomplete here
		Material *tm  = MaterialLib;
		for( int k=0; k<tobj->MaterialRef ; k++ )
			tm = tm->NxItem;
		if( strcmp( tm->MaterialClass, "Standard" ) == 0 )
		{
			SFormat("\t\tglBindTexture(GL_TEXTURE_2D, MaterialLib[%s]);",tm->MaterialName );
			Fwrite;
			LineFeed;
			SFormat( "\t\t\tglBegin( GL_TRIANGLES );");
			Fwrite;
			LineFeed;
			tmpf = tobj->FaceList;
			int fcounter = 0;
			while( tmpf != NULL )
			{
				LineFeed;
				SFormat( "\t\t\t//Face No: %d", fcounter );
				Fwrite; LineFeed;
				fcounter++;
				LineFeed;
				
				SFormat("\t\t\t\tglNormal3f( %ff, %ff, %ff );", 
					tmpf->Normalx, tmpf->Normaly, tmpf->Normalz );
				Fwrite;
				LineFeed;

				LineFeed;
				tmptv = GetTextVertex( tmpf->cTextVertex, tobj->TVertexList );
				if( tmptv != NULL )
				{
					SFormat( "\t\t\t\tglTexCoord3f( %ff, %ff, %ff );",
							tmptv->u, tmptv->v, tmptv->w );
					Fwrite;
				}
				
				LineFeed;
				tmpv = GetVertex( tmpf->c, tobj->VertexList );
				SFormat( "\t\t\t\tglVertex3f( %ff, %ff, %ff );",
					tmpv->x, tmpv->y, tmpv->z );
				Fwrite;
				LineFeed;


				LineFeed;
				tmptv = GetTextVertex( tmpf->bTextVertex, tobj->TVertexList );
				if( tmptv != NULL )
				{
					SFormat( "\t\t\t\tglTexCoord3f( %ff, %ff, %ff );",
							tmptv->u, tmptv->v, tmptv->w );
					Fwrite;
				}
				
				LineFeed;
				tmpv = GetVertex( tmpf->b, tobj->VertexList );
				SFormat( "\t\t\t\tglVertex3f( %ff, %ff, %ff );",
					tmpv->x, tmpv->y, tmpv->z );
				Fwrite;
				LineFeed;

				LineFeed;
				tmptv = GetTextVertex( tmpf->aTextVertex, tobj->TVertexList );
				if( tmptv != NULL )
				{
					SFormat( "\t\t\t\tglTexCoord3f( %ff, %ff, %ff );",
							tmptv->u, tmptv->v, tmptv->w );
					Fwrite;
				}
				
				LineFeed;
				tmpv = GetVertex( tmpf->a, tobj->VertexList );
				SFormat( "\t\t\t\tglVertex3f( %ff, %ff, %ff );",
					tmpv->x, tmpv->y, tmpv->z );
				Fwrite;
				LineFeed;
				
				
				tmpf =tmpf->NxNode;
			}
			SFormat("\t\t\tglEnd( );");
			Fwrite;
			LineFeed;
		}
		else
		{
			LineFeed;
			
			int io = 0;
			int fcounter=0;
			Material *submt = tm->SubMaterials;
			while( submt != NULL )
			{
				LineFeed;
				SFormat("\t\tglBindTexture(GL_TEXTURE_2D, MaterialLib[%s]);",
						submt->MaterialName );
				Fwrite;
				LineFeed;
				tmpf = tobj->FaceList;
				fcounter = 0;
				
				SFormat( "\t\t\tglBegin( GL_TRIANGLES );");
				Fwrite;
				LineFeed;

				while( tmpf != NULL )
				{
					if( tmpf->MaterialID == io )
					{
						LineFeed;
						SFormat( "\t\t\t//Face No: %d", fcounter );
						Fwrite; LineFeed;
						
						SFormat("\t\t\t\tglNormal3f( %ff, %ff, %ff );", 
								tmpf->Normalx, tmpf->Normaly, tmpf->Normalz );
						Fwrite;
						LineFeed;

						LineFeed;
						tmptv = GetTextVertex( tmpf->cTextVertex, tobj->TVertexList );
						SFormat( "\t\t\t\tglTexCoord3f( %ff, %ff, %ff );",
								tmptv->u, tmptv->v, tmptv->w );
						Fwrite;
				
						LineFeed;
						tmpv = GetVertex( tmpf->c, tobj->VertexList );
						SFormat( "\t\t\t\tglVertex3f( %ff, %ff, %ff );",
								tmpv->x, tmpv->y, tmpv->z );
						Fwrite;
						LineFeed;
		

						LineFeed;
						tmptv = GetTextVertex( tmpf->bTextVertex, tobj->TVertexList );
						SFormat( "\t\t\t\tglTexCoord3f( %ff, %ff, %ff );",
								tmptv->u, tmptv->v, tmptv->w );
						Fwrite;
				
						LineFeed;
						tmpv = GetVertex( tmpf->b, tobj->VertexList );
						SFormat( "\t\t\t\tglVertex3f( %ff, %ff, %ff );",
								tmpv->x, tmpv->y, tmpv->z );
						Fwrite;
						LineFeed;

						LineFeed;
						tmptv = GetTextVertex( tmpf->aTextVertex, tobj->TVertexList );
						SFormat( "\t\t\t\tglTexCoord3f( %ff, %ff, %ff );",
								tmptv->u, tmptv->v, tmptv->w );
						Fwrite;
				
						LineFeed;
						tmpv = GetVertex( tmpf->a, tobj->VertexList );
						SFormat( "\t\t\t\tglVertex3f( %ff, %ff, %ff );",
								tmpv->x, tmpv->y, tmpv->z );
						Fwrite;
						LineFeed;
					
						
					}
					
					tmpf = tmpf->NxNode;
					fcounter++;
				}
				SFormat("\t\t\tglEnd( );");
				Fwrite;
				LineFeed;
				submt = submt->NxItem;
				io++;
			}
		}
		LineFeed;
		SFormat("\tglEndList( );");
		FwriteLine;
		SFormat("}");
		FwriteLine;
		tobj = tobj->NxObject;
	}

	ExFile.Close();
}

void COpenGL_NXDlg::CheckHeads()
{
	Object *tobj = SceneObj;
	if( tobj->FaceList == NULL )
		AfxMessageBox( "Faces are Zero?");
	if( tobj->TVertexList == NULL )
		AfxMessageBox( "UVW co-ordinates absent please refer ReadMe or Click Help");
}
